// Copyright © 2008-2013 Esko Luontola <www.orfjackal.net>
// This software is released under the Apache License 2.0.
// The license text is at http://dimdwarf.sourceforge.net/LICENSE

package net.orfjackal.dimdwarf.db;

import javax.annotation.concurrent.NotThreadSafe;
import java.util.Set;

@NotThreadSafe
public class DatabaseAdapter<K1, V1, K2, V2> implements Database<K1, V1> {

    private final Database<K2, V2> parent;
    private final Converter<K1, K2> keys;
    private final Converter<V1, V2> values;

    public DatabaseAdapter(Database<K2, V2> parent, Converter<K1, K2> keys, Converter<V1, V2> values) {
        this.parent = parent;
        this.keys = keys;
        this.values = values;
    }

    public IsolationLevel getIsolationLevel() {
        return parent.getIsolationLevel();
    }

    public Set<String> getTableNames() {
        return parent.getTableNames();
    }

    public DatabaseTable<K1, V1> openTable(String name) {
        return new DatabaseTableAdapter<>(parent.openTable(name), keys, values);
    }
}
